var LaunchyShared = function() {
	this.init = false;
}

LaunchyShared.prototype.isLinkType = function(linktype, link) {
	link = link.toString();
	try {
		var protocol = link.substr(0, linktype.length);
		return protocol.toLowerCase() == linktype;
	} catch(e) {
		launchyShared.trace("Unable to get protocol from " + link);
		return false;
	}
}

// Dump message to the JavaScript console but only if you're a developer
LaunchyShared.prototype.trace = function(t, f) {
	if (f || (typeof(LaunchyContext) != "undefined" && typeof(LaunchyContext.dev) != "undefined" && LaunchyContext.dev)) {
		var CONSOLE_SERVICE = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
		try {
			CONSOLE_SERVICE.logStringMessage("Launchy: " + t);
		} catch(ex) {
			try {
				CONSOLE_SERVICE.logStringMessage("Launchy: Unable to log message. Type was <" + typeof(t) + ">");
			} catch(ex) {
			}
		}
	}
	// var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	// file.append("launchy.log");
	// CONSOLE_SERVICE.logStringMessage("file: " + file);
	// var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	// if (!this.init) {
		// foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);
		// this.init = true;
	// } else {
		// foStream.init(file, 0x02 | 0x10, 0666, 0);
	// }
	// var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
	// if (!converter) {
			// CONSOLE_SERVICE.logStringMessage("no converter");
	// }
	// converter.writeString(t + "\n");
	// converter.close();
}

LaunchyShared.prototype.openURL = function(aURL) {
	launchyShared.trace(navigator.vendor);
	if (navigator.vendor && navigator.vendor != "Thunderbird") {
		var navWindow;
		try {
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			navWindow = wm.getMostRecentWindow("navigator:browser");
		}	catch (ex) {
		}

		if (navWindow) {
			if ("delayedOpenTab" in navWindow)
				navWindow.delayedOpenTab(aURL);
			else if ("loadURI" in navWindow)
				navWindow.loadURI(aURL);
			else
				navWindow.content.location.href = aURL;
		}	else {
			var ass = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);
			ass.hiddenDOMWindow.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", aURL);
		}
	}	else {
		try {
			var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
			messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
			messenger.launchExternalURL(aURL);
		} catch (ex) {
		}
	}
}

LaunchyShared.prototype.help = function(s) {
	var url = "http://gemal.dk/mozilla/launchy.html?project=launchy";
	if (s) {
		url += "#" + s;
	}
	launchyShared.openURL(url);
}

LaunchyShared.prototype.replaceInsert = function(t, i, v) {
	var result = t;
	if (result) {
		var re = new RegExp("#" + i, "g");
		result = result.replace(re, v);
	}
	return result;
}

// create the object
const launchyShared = new LaunchyShared();
